#ifndef PASSES_FUNCTION_INLINE
#define PASSES_FUNCTION_INLINE


#include "../ir/ir.hpp"
#include "../passes/pass.hpp"
#include <unordered_map>

namespace Passes {

class FunctionInline : public Pass {
    const int INLINE_SIZE_LIMIT = 30;
    std::unordered_set<ptr<ir::ir_userfunc>> inlinable;
    ptr<ir::ir_userfunc> target;
    bool check_inlinable(ptr<ir::ir_userfunc> fun, std::string name);
    void function_inline(ptr<ir::ir_userfunc> target);
    void clone_ins(ptr<ir::ir_userfunc> caller, std::list<std::shared_ptr<ir::ir_instr>> instructions);
    ptr<ir::ir_basicblock> clone_function(ptr<ir::func_call> call_ins, ptr<ir::ir_userfunc> target, ptr<ir::ir_basicblock> end_block, ptr<ir::ir_reg> inline_ret_reg, std::unordered_map<ptr<ir::ir_value>, ptr<ir::ir_value>> replace_map);
public:
    FunctionInline(ptr<ir::ir_module> compunit) : Pass(compunit) {}
    virtual void run() override final;
    virtual std::string get_name() override final {return "Function inline";}
};

}

#endif
